### Hierarchy

- TableModel

### Implements

- PaginationModel

## Index

### Constructors

- constructor

### Properties

- _data
- _totalDataLength
- currentPage
- dataChange
- header
- isEnd
- isLoading
- pageLength
- rowsClass
- rowsContext
- rowsExpanded
- rowsExpandedChange
- rowsSelected
- rowsSelectedChange
- selectAllChange
- tableModelCount
- COUNT

### Accessors

- data
- totalDataLength

### Methods

- addColumn
- addRow
- column
- deleteColumn
- deleteRow
- expandRow
- expandedRowsCount
- getHeader
- getHeaderId
- getId
- getRowContext
- hasExpandableRows
- isRowDisabled
- isRowExpandable
- isRowExpanded
- isRowFiltered
- isRowSelected
- moveColumn
- popRowStateFromModelData
- pushRowStateToModelData
- realColumnIndex
- realIndex
- realRowIndex
- row
- selectAll
- selectRow
- selectedRowsCount
- sort

## Constructors

### constructor

- new TableModel(): TableModel

- - Defined in src/table/table-model.class.ts:188

  #### Returns TableModel

## Properties

### Protected _data

_data: TableItem[][] = [[]]

- Defined in src/table/table-model.class.ts:182

### Protected _totalDataLength

_totalDataLength: number

- Defined in src/table/table-model.class.ts:146

### currentPage

currentPage: number = 1

- Defined in src/table/table-model.class.ts:126

### dataChange

dataChange: EventEmitter<Object> = new EventEmitter()

- Defined in src/table/table-model.class.ts:70

### header

header: TableHeaderItem[] = []

- Defined in src/table/table-model.class.ts:121

### isEnd

isEnd: boolean = false

- Defined in src/table/table-model.class.ts:136

### isLoading

isLoading: boolean = false

- Defined in src/table/table-model.class.ts:141

### pageLength

pageLength: number = 10

- Defined in src/table/table-model.class.ts:131

### rowsClass

rowsClass: string[] = []

- Defined in src/table/table-model.class.ts:116

### rowsContext

rowsContext: string[] = []

- Defined in src/table/table-model.class.ts:107

### rowsExpanded

rowsExpanded: boolean[] = []

- Defined in src/table/table-model.class.ts:97

### rowsExpandedChange

rowsExpandedChange: EventEmitter<number> = new EventEmitter<number>()

- Defined in src/table/table-model.class.ts:72

### rowsSelected

rowsSelected: boolean[] = []

- Defined in src/table/table-model.class.ts:92

### rowsSelectedChange

rowsSelectedChange: EventEmitter<number> = new EventEmitter<number>()

- Defined in src/table/table-model.class.ts:71

### selectAllChange

selectAllChange: Subject<boolean> = new Subject<boolean>()

- Defined in src/table/table-model.class.ts:77

### Protected tableModelCount

tableModelCount: number = 0

- Defined in src/table/table-model.class.ts:188

### Static Protected COUNT

COUNT: number = 0

- Defined in src/table/table-model.class.ts:34

## Accessors

### data

data:

- Defined in src/table/table-model.class.ts:41
- Defined in src/table/table-model.class.ts:85

### totalDataLength

totalDataLength:

- Defined in src/table/table-model.class.ts:157
- Defined in src/table/table-model.class.ts:165

## Methods

### addColumn

- addColumn(column: TableItem[], index: number): void

- - Defined in src/table/table-model.class.ts:449

  #### Parameters

  - ##### Optional column: TableItem[]

  - ##### Optional index: number

  #### Returns void

### addRow

- addRow(row: TableItem[], index: number): void

- - Defined in src/table/table-model.class.ts:304

  #### Parameters

  - ##### Optional row: TableItem[]

  - ##### Optional index: number

  #### Returns void

### column

- column(index: number): TableItem[]

- - Defined in src/table/table-model.class.ts:421

  #### Parameters

  - ##### index: number

  #### Returns TableItem[]

### deleteColumn

- deleteColumn(index: number): void

- - Defined in src/table/table-model.class.ts:510

  #### Parameters

  - ##### index: number

  #### Returns void

### deleteRow

- deleteRow(index: number): void

- - Defined in src/table/table-model.class.ts:387

  #### Parameters

  - ##### index: number

  #### Returns void

### expandRow

- expandRow(index: number, value?: boolean): void

- - Defined in src/table/table-model.class.ts:650

  #### Parameters

  - ##### index: number

  - ##### Default value value: boolean = true

  #### Returns void

### expandedRowsCount

- expandedRowsCount(): number

- - Defined in src/table/table-model.class.ts:266

  #### Returns number

### getHeader

- getHeader(column: number): TableHeaderItem

- - Defined in src/table/table-model.class.ts:233

  #### Parameters

  - ##### column: number

  #### Returns TableHeaderItem

### getHeaderId

- getHeaderId(column: HeaderType, colSpan?: number): string

- - Defined in src/table/table-model.class.ts:210

  #### Parameters

  - ##### column: HeaderType

  - ##### Default value colSpan: number = 1

  #### Returns string

### getId

- getId(column: HeaderType, row?: number): string

- - Defined in src/table/table-model.class.ts:200

  #### Parameters

  - ##### column: HeaderType

  - ##### Default value row: number = 0

  #### Returns string

### getRowContext

- getRowContext(index: number): string

- - Defined in src/table/table-model.class.ts:410

  #### Parameters

  - ##### index: number

  #### Returns string

### hasExpandableRows

- hasExpandableRows(): boolean

- - Defined in src/table/table-model.class.ts:398

  #### Returns boolean

### isRowDisabled

- isRowDisabled(index: number): boolean

- - Defined in src/table/table-model.class.ts:639

  #### Parameters

  - ##### index: number

  #### Returns boolean

### isRowExpandable

- isRowExpandable(index: number): boolean

- - Defined in src/table/table-model.class.ts:402

  #### Parameters

  - ##### index: number

  #### Returns boolean

### isRowExpanded

- isRowExpanded(index: number): boolean

- - Defined in src/table/table-model.class.ts:406

  #### Parameters

  - ##### index: number

  #### Returns boolean

### isRowFiltered

- isRowFiltered(index: number): boolean

- - Defined in src/table/table-model.class.ts:599

  #### Parameters

  - ##### index: number

  #### Returns boolean

  true if any of the filters in header filters out the `index`th row

### isRowSelected

- isRowSelected(index: number): boolean

- - Defined in src/table/table-model.class.ts:632

  #### Parameters

  - ##### index: number

  #### Returns boolean

### moveColumn

- moveColumn(indexFrom: number, indexTo: number): void

- - Defined in src/table/table-model.class.ts:524

  #### Parameters

  - ##### indexFrom: number

  - ##### indexTo: number

  #### Returns void

### popRowStateFromModelData

- popRowStateFromModelData(): void

- - Defined in src/table/table-model.class.ts:584

  #### Returns void

### pushRowStateToModelData

- pushRowStateToModelData(): void

- - Defined in src/table/table-model.class.ts:558

  #### Returns void

### Protected realColumnIndex

- realColumnIndex(index: number): number

- - Defined in src/table/table-model.class.ts:673

  #### Parameters

  - ##### index: number

  #### Returns number

### Protected realIndex

- realIndex(index: number, length: number): number

- - Defined in src/table/table-model.class.ts:684

  #### Parameters

  - ##### index: number

  - ##### length: number

  #### Returns number

### Protected realRowIndex

- realRowIndex(index: number): number

- - Defined in src/table/table-model.class.ts:662

  #### Parameters

  - ##### index: number

  #### Returns number

### row

- row(index: number): TableItem[]

- - Defined in src/table/table-model.class.ts:285

  #### Parameters

  - ##### index: number

  #### Returns TableItem[]

### selectAll

- selectAll(value?: boolean): void

- - Defined in src/table/table-model.class.ts:623

  #### Parameters

  - ##### Default value value: boolean = true

  #### Returns void

### selectRow

- selectRow(index: number, value?: boolean): void

- - Defined in src/table/table-model.class.ts:610

  #### Parameters

  - ##### index: number

  - ##### Default value value: boolean = true

  #### Returns void

### selectedRowsCount

- selectedRowsCount(): number

- - Defined in src/table/table-model.class.ts:251

  #### Returns number

### sort

- sort(index: number): void

- - Defined in src/table/table-model.class.ts:541

  #### Parameters

  - ##### index: number

  #### Returns void

Generated using TypeDoc